"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .token_enum import TokenEnum
from compass_api_sdk.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
from pydantic import model_serializer
from typing import Union
from typing_extensions import NotRequired, TypeAliasType, TypedDict


AerodromeSwapEthForTokenParamsAmountInTypedDict = TypeAliasType(
    "AerodromeSwapEthForTokenParamsAmountInTypedDict", Union[float, str]
)
r"""The amount of ETH you will give to aerodrome_basic for this trade"""


AerodromeSwapEthForTokenParamsAmountIn = TypeAliasType(
    "AerodromeSwapEthForTokenParamsAmountIn", Union[float, str]
)
r"""The amount of ETH you will give to aerodrome_basic for this trade"""


AerodromeSwapEthForTokenParamsAmountOutMinTypedDict = TypeAliasType(
    "AerodromeSwapEthForTokenParamsAmountOutMinTypedDict", Union[float, str]
)
r"""The minimal amount of token you are willing to receive (will revert if the swap gives you less)"""


AerodromeSwapEthForTokenParamsAmountOutMin = TypeAliasType(
    "AerodromeSwapEthForTokenParamsAmountOutMin", Union[float, str]
)
r"""The minimal amount of token you are willing to receive (will revert if the swap gives you less)"""


class AerodromeSwapEthForTokenParamsTypedDict(TypedDict):
    r"""Parameters model for swapping ETH for tokens."""

    token_out: TokenEnum
    r"""A class representing the token.

    This class is used to represent the token in the system. Notice individual
    endpoints' documentation where per chain tokens are presented.
    """
    amount_in: AerodromeSwapEthForTokenParamsAmountInTypedDict
    r"""The amount of ETH you will give to aerodrome_basic for this trade"""
    amount_out_min: AerodromeSwapEthForTokenParamsAmountOutMinTypedDict
    r"""The minimal amount of token you are willing to receive (will revert if the swap gives you less)"""
    stable: bool
    r"""If true, try to trade on a stable pool with a bonding curve of K=x^3y+y^3x. If false, try to trade on a volatile pool with a bonding curve of K=xy"""
    to: NotRequired[Nullable[str]]
    r"""The receiver of the funds from this trade, default to sender"""


class AerodromeSwapEthForTokenParams(BaseModel):
    r"""Parameters model for swapping ETH for tokens."""

    token_out: TokenEnum
    r"""A class representing the token.

    This class is used to represent the token in the system. Notice individual
    endpoints' documentation where per chain tokens are presented.
    """

    amount_in: AerodromeSwapEthForTokenParamsAmountIn
    r"""The amount of ETH you will give to aerodrome_basic for this trade"""

    amount_out_min: AerodromeSwapEthForTokenParamsAmountOutMin
    r"""The minimal amount of token you are willing to receive (will revert if the swap gives you less)"""

    stable: bool
    r"""If true, try to trade on a stable pool with a bonding curve of K=x^3y+y^3x. If false, try to trade on a volatile pool with a bonding curve of K=xy"""

    to: OptionalNullable[str] = UNSET
    r"""The receiver of the funds from this trade, default to sender"""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["to"]
        nullable_fields = ["to"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in type(self).model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
